#========================================================================================
# package      DE_EPAGES::Presentation::API::Attributes::Recaptcha_Ext
# state        private
# base         DE_EPAGES::Object::API::Attributes::EncryptedStringAttribute
# description  attributes are saved as EncryptedStringAttributes.
#========================================================================================
package DE_EPAGES::Presentation::API::Attributes::Recaptcha_Ext;
use base qw( DE_EPAGES::Object::API::Attributes::EncryptedStringAttribute );

use strict;
use feature 'switch';

use DE_EPAGES::Presentation::API::Constants qw( RECAPTCHA_PUBLIC_KEY RECAPTCHA_PRIVATE_KEY);

sub getAttributes {
    my $self = shift;
    my ($Object, $aNames, $LanguageID) = @_;

    my $hInfo = {};

    foreach my $Name (@$aNames) {
        given ($Name) {
            when ([qw( ReCaptchaPublicKey ReCaptchaPrivateKey )]) {
                $hInfo->{$Name} = $self->getFromDatabaseOrEpagesConfig($Object, $Name);
            }
        }
    }

    return $hInfo;
}

sub getFromDatabaseOrEpagesConfig {
    my $self = shift;
    my ($Object, $Name) = @_;

    my $SuperValue = $self->SUPER::getAttributes($Object, [$Name])->{$Name};

    if ($Name eq 'ReCaptchaPublicKey') {
        return defined $SuperValue ? $SuperValue : RECAPTCHA_PUBLIC_KEY();
    }

    if ($Name eq 'ReCaptchaPrivateKey') {
        return defined $SuperValue ? $SuperValue : RECAPTCHA_PRIVATE_KEY();
    }
}

1;
